unit mform;

{
Программа "Видеочат"
Copyright (c) 2020 Любезный В. В.
https://www.lubezniy.ru/soft/videochat

Модуль описания класса основной (и пока единственной) формы приложения.
}

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls;

type

  { TMain_Form }

  TMain_Form = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    State_Label: TLabel;
    Stop_Button: TButton;
    Start_Button: TButton;
    Status_Timer: TTimer;
    procedure OnShow(Sender: TObject);
    procedure OnStatusTimer(Sender: TObject);
    procedure Start_ButtonClick(Sender: TObject);
    procedure Stop_ButtonClick(Sender: TObject);
  private

  public

  end;

var
  Main_Form: TMain_Form;

implementation

{$R *.lfm}

uses chatapptypes, chatapp_class, uhttpsserver;


{ TMain_Form }


{
Обработка нажатия кнопки "Запустить Web-сервер чата"
}
procedure TMain_Form.Start_ButtonClick(Sender: TObject);
begin
  // Запрещаем кнопку запуска.
  Start_Button.Enabled := False;
  // Разрешаем кнопку останова.
  Stop_Button.Enabled := True;
  // Инициализируем приложение чата.
  ChatApp.Start;
  // Устанавливаем в строке состояния надпись "запуск"
  State_Label.Caption := 'Запуск';
  // Разрешаем таймер опроса состояния.
  Status_Timer.Enabled := True;
  // Создаём и запускаем Web-сервер.
  WebServer := TTCPHttpDaemon.Create(ChatApp.WebServerConfig);
end;

{
Обработка нажатия кнопки "Остановить Web-сервер чата"
}
procedure TMain_Form.Stop_ButtonClick(Sender: TObject);
begin
  // Уничтожаем объект web-сервера
  try
    FreeAndNil(WebServer);
  except
    // В процессе уничтожения могут быть ошибки; не думаю, что на них стоит обращать внимание, просто их игнорируем.
  end;
  // Останавливаем таймер опроса состояния
  Status_Timer.Enabled := False;
  // Пишем в строке состояния сервера "остановлен"
  State_Label.Caption := 'остановлен';
  // Запрещаем кнопку остановки и разрешаем кнопку запуска
  Stop_Button.Enabled := False;
  Start_Button.Enabled := True;
end;

{
Обработка открытия окна приложения
}
procedure TMain_Form.OnShow(Sender: TObject);
begin
  // Создаём объект приложения чата.
  ChatApp := TChatApp.Create;
  // Если в командной строке первым параметром указан auto, сразу запускаем сервер.
  if ParamStr(1) = 'auto' then
  begin
    Start_ButtonClick(Sender);
  end;
end;

{
Обработка срабатывания таймера получения и отображения состояния чата
}
procedure TMain_Form.OnStatusTimer(Sender: TObject);
begin
  State_Label.Caption := ChatApp.getState;
end;

end.

